diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/course/completion.php mdl20-mitms-integration/course/completion.php
--- mdl-cvshead/course/completion.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/course/completion.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,141 @@
+<?php
+
+///////////////////////////////////////////////////////////////////////////
+//                                                                       //
+// NOTICE OF COPYRIGHT                                                   //
+//                                                                       //
+// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
+//          http://moodle.com                                            //
+//                                                                       //
+// Copyright (C) 1999 onwards Martin Dougiamas  http://dougiamas.com     //
+//                                                                       //
+// This program is free software; you can redistribute it and/or modify  //
+// it under the terms of the GNU General Public License as published by  //
+// the Free Software Foundation; either version 2 of the License, or     //
+// (at your option) any later version.                                   //
+//                                                                       //
+// This program is distributed in the hope that it will be useful,       //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
+// GNU General Public License for more details:                          //
+//                                                                       //
+//          http://www.gnu.org/copyleft/gpl.html                         //
+//                                                                       //
+///////////////////////////////////////////////////////////////////////////
+
+// Edit course completion settings
+
+require_once('../config.php');
+require_once('lib.php');
+require_once($CFG->libdir.'/completionlib.php');
+require_once($CFG->libdir.'/completion/completion_criteria_self.php');
+require_once($CFG->libdir.'/completion/completion_criteria_date.php');
+require_once($CFG->libdir.'/completion/completion_criteria_unenrol.php');
+require_once($CFG->libdir.'/completion/completion_criteria_activity.php');
+require_once($CFG->libdir.'/completion/completion_criteria_duration.php');
+require_once($CFG->libdir.'/completion/completion_criteria_grade.php');
+require_once($CFG->libdir.'/completion/completion_criteria_role.php');
+require_once('completion_form.php');
+
+$id = required_param('id', PARAM_INT);       // course id
+
+/// basic access control checks
+if ($id) { // editing course
+
+    if($id == SITEID){
+        // don't allow editing of  'site course' using this from
+        print_error('cannoteditsiteform');
+    }
+
+    if (!$course = $DB->get_record('course', array('id'=>$id))) {
+        print_error('invalidcourseid');
+    }
+    require_login($course->id);
+    require_capability('moodle/course:update', get_context_instance(CONTEXT_COURSE, $course->id));
+
+} else {
+    require_login();
+    print_error('needcourseid');
+}
+
+
+/// first create the form
+$form = new course_completion_form('completion.php?id='.$id, compact('course'));
+
+// now override defaults if course already exists
+if ($form->is_cancelled()){
+    redirect($CFG->wwwroot.'/course/view.php?id='.$course->id);
+
+} else if ($data = $form->get_data()) {
+
+    $completion = new completion_info($course);
+
+/// process criteria unlocking if requested
+    if (!empty($data->settingsunlock)) {
+
+        $completion->delete_course_completion_data();
+
+        // Return to form (now unlocked)
+        redirect($CFG->wwwroot."/course/completion.php?id=$course->id");
+    }
+
+/// process data if submitted
+    // Delete old criteria
+    $completion->clear_criteria();
+
+    // Loop through each criteria type and run update_config
+    global $COMPLETION_CRITERIA_TYPES;
+    foreach ($COMPLETION_CRITERIA_TYPES as $type) {
+        $class = 'completion_criteria_'.$type;
+        $criterion = new $class();
+        $criterion->update_config($data);
+    }
+
+    // Handle aggregation methods
+    // Overall aggregation
+    $aggregation = new completion_aggregation();
+    $aggregation->course = $data->id;
+    $aggregation->criteriatype = null;
+    $aggregation->setMethod($data->overall_aggregation);
+    $aggregation->insert();
+
+    // Activity aggregation
+    if (empty($data->activity_aggregation)) {
+        $data->activity_aggregation = 0;
+    }
+
+    $aggregation = new completion_aggregation();
+    $aggregation->course = $data->id;
+    $aggregation->criteriatype = COMPLETION_CRITERIA_TYPE_ACTIVITY;
+    $aggregation->setMethod($data->activity_aggregation);
+    $aggregation->insert();
+
+    // Role aggregation
+    $aggregation = new completion_aggregation();
+    $aggregation->course = $data->id;
+    $aggregation->criteriatype = COMPLETION_CRITERIA_TYPE_ROLE;
+    $aggregation->setMethod($data->role_aggregation);
+    $aggregation->insert();
+
+    redirect($CFG->wwwroot."/course/view.php?id=$course->id");
+}
+
+
+/// Print the form
+
+$streditcompletionsettings = get_string("editcoursecompletionsettings", 'completion');
+$navlinks = array();
+
+$navlinks[] = array('name' => $streditcompletionsettings,
+                    'link' => null,
+                    'type' => 'misc');
+$title = $streditcompletionsettings;
+$fullname = $course->fullname;
+
+$navigation = build_navigation($navlinks);
+print_header($title, $fullname, $navigation, $form->focus());
+print_heading($streditcompletionsettings);
+
+$form->display();
+
+print_footer($course);
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/course/report/progress/index.php mdl20-mitms-integration/course/report/progress/index.php
--- mdl-cvshead/course/report/progress/index.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/course/report/progress/index.php	2009-08-25 16:21:21.000000000 +1200
@@ -50,17 +50,21 @@
     require_capability('moodle/site:accessallgroups',$context);
 }
 
-// Get data on activities and progress of all users, and give error if we've
-// nothing to display (no users or no activities)
+// Get data on activities, criteria and progress of all users, and give error if we've
+// nothing to display (no users, no activities or no criteria)
 $reportsurl=$CFG->wwwroot.'/course/report.php?id='.$course->id;
 $completion=new completion_info($course);
 $activities=$completion->get_activities();
-if(count($activities)==0) {
+$criteria   = $completion->has_criteria() ? $completion->get_criteria() : false;
+
+if(empty($activities) && empty($criteria)) {
     print_error('err_noactivities','completion',$reportsurl);
 }
 
-$progress=$completion->get_progress_all($firstnamesort,$group,
-    $csv ? 0 :COMPLETION_REPORT_PAGE,$csv ? 0 : $start);
+$progress = $completion->get_progress_all(
+    $firstnamesort, $group,
+    $csv ? 0 : COMPLETION_REPORT_PAGE,
+    $csv ? 0 : $start);
 
 if($csv) {
     header('Content-Disposition: attachment; filename=progress.'.
@@ -125,6 +129,32 @@
     $pagingbar='';
 }
 
+
+// Can we mark users as complete?
+// (if the logged in user has a role defined in the role criteria)
+$allow_marking = false;
+$allow_marking_criteria = null;
+
+if ($criteria) {
+    // Get role criteria
+    $rcriteria = $completion->get_criteria(COMPLETION_CRITERIA_TYPE_ROLE);
+
+    if (!empty($rcriteria)) {
+
+        foreach ($rcriteria as $rcriterion) {
+            $users = get_role_users($rcriterion->role, $context, true);
+
+            // If logged in user has this role, allow marking complete
+            if (in_array($USER->id, array_keys($users))) {
+                $allow_marking = true;
+                $allow_marking_criteria = $rcriterion->id;
+                break;
+            }
+        }
+    }
+}
+
+
 // Okay, let's draw the table of progress info,
 
 // Start of table
@@ -182,7 +212,7 @@
         print '<th scope="col" class="'.$activity->datepassedclass.'">'.
             '<a href="'.$CFG->wwwroot.'/mod/'.$activity->modname.
             '/view.php?id='.$activity->id.'">'.
-            '<img src="'.$OUTPUT->mod_icon_url('icon', $activity->modname).'/icon.gif" alt="'.
+            '<img src="'.$OUTPUT->mod_icon_url('icon', $activity->modname).'" alt="'.
             get_string('modulename',$activity->modname).'" /> <span class="completion-activityname">'.
             format_string($activity->name).'</span></a>';
         if($activity->completionexpected) {
@@ -192,6 +222,37 @@
     }
 }
 
+// Course completion criteria
+if ($criteria) {
+
+    foreach ($criteria as $criterion) {
+
+        // Ignore activity completion criteria (use existing activity cols instead)
+        if ($criterion->criteriatype == COMPLETION_CRITERIA_TYPE_ACTIVITY) {
+            continue;
+        }
+
+        if ($csv) {
+            print $sep.csv_quote(strip_tags($criterion->get_title()));
+        } else {
+            print '<th scope="col">'.format_text($criterion->get_title()).'</th>';
+        }
+    }
+
+    // Overall course completion status
+    if ($csv) {
+        print $sep.csv_quote(strip_tags(get_string('coursecomplete', 'completion')));
+    } else {
+        print '<th scope="col">'.get_string('coursecomplete', 'completion').'</th>';
+    }
+
+    // Mark complete?
+    if (!$csv && $allow_marking) {
+        print '<th scope="col">'.get_string('markcomplete', 'completion').'</th>';
+    }
+}
+
+
 if($csv) {
     print $line;
 } else {
@@ -247,15 +308,101 @@
         $a->activity=strip_tags($activity->name);
         $fulldescribe=get_string('progress-title','completion',$a);
 
+        // Check if this activity has a dependant couse completion criteria
+        $is_criteria = false;
+        if ($criteria) {
+            foreach ($criteria as $criterion) {
+                if ($criterion->criteriatype != COMPLETION_CRITERIA_TYPE_ACTIVITY) {
+                    continue;
+                }
+
+                if ($criterion->moduleinstance === $activity->id) {
+                    $is_criteria = true;
+                    break;
+                }
+            }
+        }
+
         if($csv) {
             print $sep.csv_quote($describe).$sep.csv_quote($date);
         } else {
-            print '<td class="completion-progresscell '.$activity->datepassedclass.'">'.
+            print '<td class="completion-progresscell '.$activity->datepassedclass.'"'.
+                ($is_criteria ? '' : ' style="background-color: #ccc;"').'>'.
                 '<img src="'.$OUTPUT->old_icon_url('i/'.$completionicon).
                 '" alt="'.$describe.'" title="'.$fulldescribe.'" /></td>';
         }
     }
 
+    // Progress for each course completion criteria
+    if ($criteria) {
+        foreach ($criteria as $criterion) {
+
+            // Ignore activity completion criteria
+            if ($criterion->criteriatype == COMPLETION_CRITERIA_TYPE_ACTIVITY) {
+                continue;
+            }
+
+            $criteria_completion = $completion->get_user_completion($user->id, $criterion);
+            $is_complete = $criteria_completion->is_complete();
+
+            $completiontype = $is_complete ? 'y' : 'n';
+            $describe = get_string('completion-alt-auto-'.$completiontype, 'completion');
+
+            $a = new StdClass;
+            $a->state    = $describe;
+            $a->date     = $is_complete ? userdate($criteria_completion->timecompleted) : '';
+            $a->user     = fullname($user);
+            $a->activity = strip_tags($criterion->get_title());
+            $fulldescribe = get_string('progress-title', 'completion', $a);
+
+            if ($csv) {
+                print $sep.csv_quote($describe);
+            } else {
+                print '<td class="completion-progresscell">'.
+                    '<img src="'.$OUTPUT->old_icon_url('i/completion-auto-'.$completiontype).
+                    '" alt="'.$describe.'" title="'.$fulldescribe.'" /></td>';
+            }
+        }
+
+        // Course completion
+        $completiontype =  $completion->is_course_complete($user->id) ? 'y' : 'n';
+        $describe = get_string('completion-alt-auto-'.$completiontype, 'completion');
+
+        $a = new StdClass;
+        $a->state    = $describe;
+        $a->date     = '';
+        $a->user     = fullname($user);
+        $a->activity = strip_tags(get_string('coursecomplete', 'completion'));
+        $fulldescribe = get_string('progress-title', 'completion', $a);
+
+        if ($csv) {
+            print $sep.csv_quote($describe);
+        } else {
+            print '<td class="completion-progresscell">'.
+                '<img src="'.$OUTPUT->old_icon_url('i/completion-auto-'.$completiontype).
+                '" alt="'.$describe.'" title="'.$fulldescribe.'" /></td>';
+        }
+
+        if ($allow_marking) {
+
+            foreach ($criteria as $criterion) {
+                if ($criterion->id == $allow_marking_criteria) {
+
+                    $criteria_completion = $completion->get_user_completion($user->id, $criterion);
+                    $marked_complete = $criteria_completion->is_complete() ? 'y' : 'n';
+                    break;
+                }
+            }
+
+            $describe = get_string('completion-alt-auto-'.$marked_complete.'completion');
+
+            print '<td class="completion-progresscell">'.
+                '<a href="'.$CFG->wwwroot.'/course/togglecompletion.php?user='.$user->id.'&course='.$course->id.'&rolec='.$allow_marking_criteria.'">'.
+                '<img src="'.$OUTPUT->old_icon_url('i/completion-manual-'.$marked_complete).
+                '" alt="'.$describe.'" title="Mark as complete" /></a></td>';
+        }
+    }
+
     if($csv) {
         print $line;
     } else {
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/course/togglecompletion.php mdl20-mitms-integration/course/togglecompletion.php
--- mdl-cvshead/course/togglecompletion.php	2009-05-23 00:09:47.000000000 +1200
+++ mdl20-mitms-integration/course/togglecompletion.php	2009-08-25 16:20:28.000000000 +1200
@@ -1,12 +1,81 @@
 <?php
-// Toggles the manual completion flag for a particular activity and the current
+// Toggles the manual completion flag for a particular activity or course completion and the current
 // user.
 
 require_once('../config.php');
 require_once($CFG->libdir.'/completionlib.php');
 
 // Parameters
-$cmid=required_param('id',PARAM_INT);
+$cmid = optional_param('id', 0, PARAM_INT);
+$courseid = optional_param('course', 0, PARAM_INT);
+$confirm = optional_param('confirm', 0, PARAM_BOOL);
+
+if (!$cmid && !$courseid) {
+    print_error('invalidarguments');
+}
+
+// Process self completion
+if ($courseid) {
+
+    // Check user is logged in
+    $course = $DB->get_record('course', array('id' => $courseid));
+    require_login($course);
+
+    $completion = new completion_info($course);
+
+    // Check if we are marking a user complete via the completion report
+    $user = optional_param('user', 0, PARAM_INT);
+    $rolec = optional_param('rolec', 0, PARAM_INT);
+
+    if ($user && $rolec) {
+
+        $criteria = completion_criteria::factory((object) array('id'=>$rolec, 'criteriatype'=>COMPLETION_CRITERIA_TYPE_ROLE));
+        $criteria_completions = $completion->get_completions($user, COMPLETION_CRITERIA_TYPE_ROLE);
+
+        foreach ($criteria_completions as $criteria_completion) {
+            if ($criteria_completion->criteriaid == $rolec) {
+                $criteria->complete($criteria_completion);
+                break;
+            }
+        }
+
+        // Return to previous page
+        if (!empty($_SERVER['HTTP_REFERER'])) {
+            redirect($_SERVER['HTTP_REFERER']);
+        } else {
+            redirect('view.php?id='.$course->id);
+        }
+
+    } else {
+
+        // Confirm with user
+        if ($confirm) {
+            $completion = $completion->get_completion($USER->id, COMPLETION_CRITERIA_TYPE_SELF);
+
+            if (!$completion) {
+                print_error('noselfcompletioncriteria', 'completion');
+            }
+
+            // Check if the user has already marked themselves as complete
+            if ($completion->is_complete()) {
+                print_error('useralreadymarkedcomplete', 'completion');
+            }
+
+            $completion->mark_complete();
+
+            redirect($CFG->wwwroot.'/course/view.php?id='.$courseid);
+            return;
+        }
+
+        $strconfirm = get_string('confirmselfcompletion', 'completion');
+        print_header_simple($strconfirm, '', build_navigation(array(array('name' => $strconfirm, 'link' => '', 'type' => 'misc'))));
+        notice_yesno($strconfirm, $CFG->wwwroot.'/course/togglecompletion.php?course='.$courseid.'&confirm=1', $CFG->wwwroot.'/course/view.php?id='.$courseid); 
+        print_simple_box_end();
+        print_footer($course);
+        exit;
+    }
+}
+
 $targetstate=required_param('completionstate',PARAM_INT);
 switch($targetstate) {
     case COMPLETION_COMPLETE:
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lang/en_utf8/block_completionstatus.php mdl20-mitms-integration/lang/en_utf8/block_completionstatus.php
--- mdl-cvshead/lang/en_utf8/block_completionstatus.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lang/en_utf8/block_completionstatus.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,3 @@
+<?php
+
+$string['completionstatus'] = 'Course Completion Status';
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lang/en_utf8/block_selfcompletion.php mdl20-mitms-integration/lang/en_utf8/block_selfcompletion.php
--- mdl-cvshead/lang/en_utf8/block_selfcompletion.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lang/en_utf8/block_selfcompletion.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,4 @@
+<?php
+
+$string['selfcompletion'] = 'Self Completion';
+$string['completecourse'] = 'Complete Course';
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lang/en_utf8/completion.php mdl20-mitms-integration/lang/en_utf8/completion.php
--- mdl-cvshead/lang/en_utf8/completion.php	2009-07-17 09:18:14.000000000 +1200
+++ mdl20-mitms-integration/lang/en_utf8/completion.php	2009-08-25 16:20:28.000000000 +1200
@@ -1,5 +1,9 @@
 <?php
+$string['activitiescompleted']='Activities completed';
 $string['activitycompletion']='Activity completion';
+$string['afterspecifieddate']='After specified date';
+$string['aggregationmethod']='Aggregation method';
+$string['any']='Any';
 $string['badautocompletion']='When you select automatic completion, you must also enable at least one requirement (below).';
 $string['completedunlocked']='Completion options unlocked';
 $string['completedunlockedtext']='When you save changes, completion state for all users will be erased. If you change your mind about this, do not save the form.';
@@ -19,33 +23,62 @@
 $string['completion_automatic']='Show activity as complete when conditions are met';
 $string['completion_manual']='Users can manually mark the activity as completed';
 $string['completion_none']='Do not indicate activity completion';
-$string['completionenabled']='Enabled, control via activity settings';
+$string['completionenabled']='Enabled, control via completion and activity settings';
 $string['completionexpected']='Expect completed on';
 $string['completiondisabled']='Disabled, not shown in activity settings';
+$string['completionmenuitem']='Completion';
 $string['completionreport']='Completion progress report';
+$string['completionsettingslocked']='Completion settings locked';
 $string['completionusegrade']='Require grade';
 $string['completionusegrade_text']='User must receive a grade';
 $string['completionview']='Require view';
 $string['completionview_text']='User must view activity';
 $string['configenablecompletion'] = 'When enabled, this lets you turn on completion tracking (progress) features at course level.';
 $string['configprogresstrackedroles'] = 'Roles that are displayed in the progress-tracking screen. (Usually includes just students and equivalent roles.)';
+$string['confirmselfcompletion']='Confirm self completion';
+$string['coursecomplete']='Course Complete';
+$string['criteria']='Criteria';
+$string['criteriarequiredall']='All criteria below are required';
+$string['criteriarequiredany']='Any criteria below are required';
 $string['csvdownload']='Download in spreadsheet format (UTF-8 .csv)';
+$string['editcoursecompletionsettings']='Edit Course Completion Settings';
 $string['excelcsvdownload']='Download in Excel-compatible format (.csv)';
 $string['enablecompletion'] = 'Enable completion tracking';
+$string['enrolmentduration']='Days left';
 $string['err_noactivities']='Completion information is not enabled for any activity, so none can be displayed. You can enable completion information by editing the settings for an activity.';
+$string['err_nograde']='A course pass grade has not been set for this course. To enable this criteria type you must create a pass grade for this course.';
+$string['err_noroles']='There are no roles with the capability \'moodle/course:markcomplete\' in this course. You can enable this criteria type by adding this capability to role(s).';
+$string['err_settingslocked']='One or more users have already completed a criteria so the settings have been locked. Unlocking the completion criteria settings will delete any existing user data and may cause confusion.';
 $string['err_nousers']='There are no users on this course or group for whom completion information is displayed. (By default, completion information is displayed only for students, so if there are no students, you will see this error. Administrators can alter this option via the admin screens.)';
 $string['err_system']='An internal error occurred in the completion system. (System administrators can enable debugging information to see more detail.)';
+$string['daysafterenrolment']='Days after enrolment';
+$string['durationafterenrolment']='Duration after enrolment';
+$string['fraction']='Fraction';
 $string['help_completion']='completion tracking';
 $string['help_completionexpected']='the date completion is expected'; 
 $string['help_completionlocked']='locked completion options';
 $string['help_completionview']='requiring view to complete';
+$string['inprogress']='In progress';
+$string['manualcompletionby']='Manual completion by';
+$string['manualselfcompletion']='Manual self completion';
+$string['markcomplete']='Mark complete';
+$string['notenroled']='You are not enroled as a student in this course';
+$string['notyetstarted']='Not yet started';
+$string['overallcriteriaaggregation']='Overall critieria type aggregation';
+$string['passinggrade']='Passing grade';
+$string['pending']='Pending';
 $string['progress']='Student progress';
 $string['progress-title']='$a->user, $a->activity: $a->state $a->date';
 $string['progresstrackedroles'] = 'Progress-tracked roles';
 $string['reportpage']='Showing users {$a->from} to {$a->to} of {$a->total}.';
+$string['requiredcriteria']='Required Criteria';
 $string['restoringcompletiondata']='Writing completion data';
 $string['saved']='Saved';
+$string['selfcompletion']='Self completion';
+$string['unit']='Unit';
+$string['unenrolment']='Unenrolment';
 $string['unlockcompletion']='Unlock completion options';
+$string['unlockcompletiondelete']='Unlock completion options and delete user completion data';
 $string['writingcompletiondata']='Writing completion data';
 $string['completionicons']='progress tick boxes';
 $string['yourprogress']='Your progress';
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lang/en_utf8/role.php mdl20-mitms-integration/lang/en_utf8/role.php
--- mdl-cvshead/lang/en_utf8/role.php	2009-08-25 11:49:00.000000000 +1200
+++ mdl20-mitms-integration/lang/en_utf8/role.php	2009-08-25 16:20:29.000000000 +1200
@@ -64,6 +64,7 @@
 $string['course:managegroups'] = 'Manage groups';
 $string['course:managemetacourse'] = 'Manage metacourse';
 $string['course:managescales'] = 'Manage scales';
+$string['course:markcomplete'] = 'Mark user\'s complete';
 $string['course:request'] = 'Request new courses';
 $string['course:reset'] = 'Reset course';
 $string['course:sectionvisibility'] = 'Control section visibility';
diff -urwN -X /home/jonathan/diff/exclude.txt mdl-cvshead/lib/completion/completion_aggregation.php mdl20-mitms-integration/lib/completion/completion_aggregation.php
--- mdl-cvshead/lib/completion/completion_aggregation.php	1970-01-01 12:00:00.000000000 +1200
+++ mdl20-mitms-integration/lib/completion/completion_aggregation.php	2009-08-25 16:20:28.000000000 +1200
@@ -0,0 +1,114 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Course completion critieria aggregation
+ *
+ * @package   moodlecore
+ * @copyright 2009 Catalyst IT Ltd
+ * @author    Aaron Barnes <aaronb@catalyst.net.nz>
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+require_once($CFG->libdir.'/data_object.php');
+
+/**
+ * Course completion critieria aggregation
+ */
+class completion_aggregation extends data_object {
+
+    /**
+     * DB Table
+     * @var string $table
+     */
+    public $table = 'course_completion_aggr_methd';
+
+    /**
+     * Array of required table fields, must start with 'id'.
+     * @var array $required_fields
+     */
+    public $required_fields = array('id', 'course', 'criteriatype', 'method', 'value');
+
+    /**
+     * Course id
+     * @access  public
+     * @var     int
+     */
+    public $course;
+
+    /**
+     * Criteria type this aggregation method applies to, or NULL for overall course aggregation
+     * @access  public
+     * @var     int
+     */
+    public $criteriatype;
+
+    /**
+     * Aggregation method (COMPLETION_AGGREGATION_* constant)
+     * @access  public
+     * @var     int
+     */
+    public $method;
+
+    /**
+     * Method value
+     * @access  public
+     * @var     mixed
+     */
+    public $value;
+
+
+    /**
+     * Finds and returns a data_object instance based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return object data_object instance or false if none found.
+     */
+    public static function fetch($params) {
+        return self::fetch_helper('course_completion_aggr_methd', __CLASS__, $params);
+    }
+
+
+    /**
+     * Finds and returns all data_object instances based on params.
+     * @static abstract
+     *
+     * @param array $params associative arrays varname=>value
+     * @return array array of data_object insatnces or false if none found.
+     */
+    public static function fetch_all($params) {}
+
+    /**
+     * Set the aggregation method
+     * @access  public
+     * @param   $method     int
+     * @return  void
+     */
+    public function setMethod($method) {
+        $methods = array(
+            COMPLETION_AGGREGATION_ALL,
+            COMPLETION_AGGREGATION_ANY,
+        );
+
+        if (in_array($method, $methods)) {
+            $this->method = $method;
+        } else {
+            $this->method = COMPLETION_AGGREGATION_ALL;
+        }
+    }
+}
